## ocamlagrep 1.0

=== Makefile ===
CAMLSTDLIB=`ocamlc -where`
DESTDIR=$(CAMLSTDLIB)/agrep

OCAMLC=ocamlc -g
OCAMLOPT=ocamlopt
OCAMLMKLIB=ocamlmklib
OCAMLDEP=ocamldep
CFLAGS=-O -D_XOPEN_SOURCE=500

C_OBJS=engine.o
CAML_OBJS=agrep.cmo

all: libagrep.a agrep.cma agrep.cmxa

agrep.cma: $(CAML_OBJS)
	$(OCAMLMKLIB) -o agrep $(CAML_OBJS)

agrep.cmxa: $(CAML_OBJS:.cmo=.cmx)
	$(OCAMLMKLIB) -o agrep $(CAML_OBJS:.cmo=.cmx)

libagrep.a: $(C_OBJS)
	$(OCAMLMKLIB) -o agrep $(C_OBJS)

install:
	mkdir -p $(DESTDIR)
	cp agrep.cmi agrep.cma agrep.cmxa $(DESTDIR)
	cp libagrep.a $(DESTDIR)
	if test -f dllagrep.so; then cp dllagrep.so $(DESTDIR); fi
	destdir=$(DESTDIR); ldconf=$(CAMLSTDLIB)/ld.conf; \
        if test `grep -s -c '^'$$destdir'$$' $$ldconf || :` = 0; \
        then echo $$destdir >> $$ldconf; fi

testagrep: testagrep.ml agrep.cma libagrep.a
	$(OCAMLC) -I . -custom -o $@ agrep.cma testagrep.ml

clean::
	rm -f testagrep

.SUFFIXES: .ml .mli .cmo .cmi .cmx

.mli.cmi:
	$(OCAMLC) -c $<

.ml.cmo:
	$(OCAMLC) -c $<

.ml.cmx:
	$(OCAMLOPT) -c $<

.c.o:
	$(OCAMLC) -ccopt "$(CFLAGS)" -c $<

clean::
	rm -f *.cm* *.o *.a *.so

depend:
	$(OCAMLDEP) *.ml *.mli > .depend

engine.o: skeleton.h

include .depend

=== debian/changelog ===
ocamlagrep (1.0-13) unstable; urgency=medium

  * Team upload
  * Update Vcs-*
  * Fix compilation with OCaml 4.08.0

 -- Stéphane Glondu <glondu@debian.org>  Wed, 04 Sep 2019 22:15:26 +0200

ocamlagrep (1.0-12) unstable; urgency=low

  [ Stéphane Glondu ]
  * Team upload
  * Bump debhelper compat to 10 and switch to dh
  * Switch source package format to 3.0 (quilt)
  * Update Vcs-*

  [ Sylvain Le Gall ]
  * Remove Sylvain Le Gall from uploaders (Closes: #869319)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 27 Jul 2017 06:16:32 +0200

ocamlagrep (1.0-11) unstable; urgency=low

  * Use dh-ocaml 0.9.1 features
  * Add homepage field and update debian/watch to point to
    forge.ocamlcore.org
  * Add myself to Uploaders
  * Upgrade Standards-Version to 3.8.3 (section ocaml)

 -- Sylvain Le Gall <gildor@debian.org>  Thu, 17 Dec 2009 00:10:18 +0000

ocamlagrep (1.0-10) unstable; urgency=low

  [ Stefano Zacchiroli ]
  * fix vcs-svn field to point just above the debian/ dir

  [ Ralf Treinen ]
  * Changed doc-base section to Programming/OCaml

  [ Samuel Mimram ]
  * Switch packaging to git
  * Use dh-ocaml.
  * Update compat to 7.
  * Update standards version to 3.8.0.

 -- Samuel Mimram <smimram@debian.org>  Tue, 24 Feb 2009 18:38:46 +0100

ocamlagrep (1.0-9) unstable; urgency=low

  * Rebuild with OCaml 3.10.

 -- Samuel Mimram <smimram@debian.org>  Sat, 08 Sep 2007 01:11:09 +0200

ocamlagrep (1.0-8) unstable; urgency=low

  * Rebuild with OCaml 3.09.2.
  * Update standards version to 3.7.2, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Thu, 18 May 2006 16:48:03 +0000

ocamlagrep (1.0-7) unstable; urgency=low

  * Correctly generating the dependencies on ocaml-nox, closes: #347457.

 -- Samuel Mimram <smimram@debian.org>  Tue, 10 Jan 2006 22:25:30 +0100

ocamlagrep (1.0-6) unstable; urgency=low

  [ Julien Cristau ]
  * Stop hardcoding the OCaml version number in the package.

  [ Samuel Mimram ]
  * Updated watch file.
  * Rebuild with OCaml 3.09.1.

 -- Samuel Mimram <smimram@debian.org>  Sat,  7 Jan 2006 13:18:00 +0100

ocamlagrep (1.0-5) unstable; urgency=low

  * Updated to OCaml 3.09.0.
  * Updated standards version to 3.6.2, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Wed,  9 Nov 2005 19:50:04 +0100

ocamlagrep (1.0-4) unstable; urgency=medium

  * Updated to OCaml 3.08.3.
  * Set Debian OCaml Maintainers as Maintainer and put myself in Uploaders.

 -- Samuel Mimram <smimram@debian.org>  Wed, 23 Mar 2005 15:04:47 +0100

ocamlagrep (1.0-3) unstable; urgency=low

   * Installing agrep.a since gcc seems to look for it when compiling with
     ocamlopt, closes: #293696.
   * Changed my email since I'm a DD now.

 -- Samuel Mimram <smimram@debian.org>  Tue,  8 Feb 2005 00:40:27 +0100

ocamlagrep (1.0-2) unstable; urgency=low

  * Build with OCaml 3.08.
  * Depends on -nox version of ocaml packages.

 -- Samuel Mimram <samuel.mimram@ens-lyon.org>  Wed, 21 Jul 2004 18:48:42 +0200

ocamlagrep (1.0-1) unstable; urgency=low

  * Initial Release.

 -- Samuel Mimram <samuel.mimram@ens-lyon.org>  Wed, 21 Jan 2004 17:58:10 +0100

=== debian/control ===
Source: ocamlagrep
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Samuel Mimram <smimram@debian.org>
Build-Depends: debhelper (>= 10), dh-ocaml (>= 0.9.1), ocaml-nox (>= 3.11)
Standards-Version: 3.8.3
Vcs-Git: https://salsa.debian.org/ocaml-team/ocamlagrep.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocamlagrep
Homepage: http://forge.ocamlcore.org/projects/ocamlagrep/

Package: libagrep-ocaml-dev
Architecture: any
Depends: libagrep-ocaml (= ${binary:Version}), ${ocaml:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: Wu-Manber algorithm for string searching with errors
 This OCaml library implements the Wu-Manber algorithm for string searching
 with errors, popularized by the "agrep" Unix command and the "glimpse" file
 indexing tool. It was developed as part of a search engine for a largish MP3
 collection; the "with error" searching comes handy for those who can't spell
 Liszt or Shostakovitch.
 .
 Given a search pattern and a string, this algorithm determines whether the
 string contains a substring that matches the pattern up to a parameterizable
 number N of "errors". An "error" is either a substitution (replace a
 character of the string with another character), a deletion (remove a
 character) or an insertion (add a character to the string). In more
 scientific terms, the number of errors is the Levenshtein edit distance
 between the pattern and the matched substring.
 .
 The search patterns are roughly those of the Unix shell, including
 one-character wildcard (?), character classes ([0-9]) and multi-character
 wildcard (*). In addition, conjunction (&) and alternative (|) are supported.
 General regular expressions are not supported, however.
 .
 This package contains all the development stuff you need to use
 the agrep OCaml library in your programs.

Package: libagrep-ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: Wu-Manber algorithm for string searching with errors
 This OCaml library implements the Wu-Manber algorithm for string searching
 with errors, popularized by the "agrep" Unix command and the "glimpse" file
 indexing tool. It was developed as part of a search engine for a largish MP3
 collection; the "with error" searching comes handy for those who can't spell
 Liszt or Shostakovitch.
 .
 Given a search pattern and a string, this algorithm determines whether the
 string contains a substring that matches the pattern up to a parameterizable
 number N of "errors". An "error" is either a substitution (replace a
 character of the string with another character), a deletion (remove a
 character) or an insertion (add a character to the string). In more
 scientific terms, the number of errors is the Levenshtein edit distance
 between the pattern and the matched substring.
 .
 The search patterns are roughly those of the Unix shell, including
 one-character wildcard (?), character classes ([0-9]) and multi-character
 wildcard (*). In addition, conjunction (&) and alternative (|) are supported.
 General regular expressions are not supported, however.
 .
 This package contains only the shared runtime stub libraries.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/ocaml/ocamlinit.mk

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O3
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) libagrep.a agrep.cma
ifneq ($(OCAML_OPT_ARCH),)
	$(MAKE) agrep.cmxa
endif

.PHONY: override_dh_clean
override_dh_clean:
	rm -rf debian/doc

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p debian/tmp/$(OCAML_STDLIB_DIR)/agrep
	# Default install doesn't handle no-ocamlopt platforms
	cp $(wildcard *.cmi *.cma *.cmxa *.a *.so *.mli) debian/tmp/$(OCAML_STDLIB_DIR)/agrep
	mkdir -p debian/doc/html
	$(OCAML_OCAMLDOC) -html -m A -keep-code -d debian/doc/html agrep.mli

## ocamlagrep 1.1

=== Makefile ===
OCAMLC=ocamlc -g -bin-annot
OCAMLOPT=ocamlopt -bin-annot
OCAMLMKLIB=ocamlmklib
OCAMLDEP=ocamldep
CFLAGS=-O -D_XOPEN_SOURCE=500 -DCAML_NAME_SPACE

C_OBJS=engine.o
CAML_OBJS=agrep.cmo

all: libagrep.a agrep.cma agrep.cmxa

agrep.cma: $(CAML_OBJS)
	$(OCAMLMKLIB) -o agrep $(CAML_OBJS)

agrep.cmxa: $(CAML_OBJS:.cmo=.cmx)
	$(OCAMLMKLIB) -o agrep $(CAML_OBJS:.cmo=.cmx)

libagrep.a: $(C_OBJS)
	$(OCAMLMKLIB) -o agrep $(C_OBJS)

install:
	ocamlfind install agrep META \
	  agrep.mli agrep.cmi agrep.cmti agrep.cma agrep.cmxa agrep.a \
          libagrep.a $(wildcard dllagrep.*)

uninstall:
	ocamlfind remove agrep

testagrep: testagrep.ml agrep.cma libagrep.a
	$(OCAMLC) -I . -custom -o $@ agrep.cma testagrep.ml

clean::
	rm -f testagrep

.SUFFIXES: .ml .mli .cmo .cmi .cmx

.mli.cmi:
	$(OCAMLC) -c $<

.ml.cmo:
	$(OCAMLC) -c $<

.ml.cmx:
	$(OCAMLOPT) -c $<

.c.o:
	$(OCAMLC) -ccopt "$(CFLAGS)" -c $<

clean::
	rm -f *.cm* *.o *.a *.so

depend:
	$(OCAMLDEP) *.ml *.mli > .depend

engine.o: skeleton.h

include .depend

=== debian/changelog ===
ocamlagrep (1.1-1build3) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 16 Jun 2025 10:20:53 +0200

ocamlagrep (1.1-1build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 28 Jan 2025 18:36:07 +0100

ocamlagrep (1.1-1build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:08:14 +0200

ocamlagrep (1.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release (Closes: #1073889)
  * Update Homepage
  * Bump Standards-Version to 4.7.0

 -- Stéphane Glondu <glondu@debian.org>  Fri, 09 Aug 2024 07:58:29 +0200

ocamlagrep (1.0-15) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Stéphane Glondu <glondu@debian.org>  Sat, 02 Sep 2023 09:55:13 +0200

ocamlagrep (1.0-14) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.6.2
  * Add Rules-Requires-Root: no
  * Remove Samuel from Uploaders

  [ Ralf Treinen ]
  * debian/watch:
    - switch to github location
    - version 4 (no change)
  * drop dh_clean override, use debian/clean file instead
  * debian/copyright: convert to format 1.0

 -- Stéphane Glondu <glondu@debian.org>  Sat, 12 Aug 2023 11:23:45 +0200

=== debian/rules ===
--- 
+++ 
@@ -27,10 +27,6 @@
 	$(MAKE) agrep.cmxa
 endif
 
-.PHONY: override_dh_clean
-override_dh_clean:
-	rm -rf debian/doc
-
 .PHONY: override_dh_auto_install
 override_dh_auto_install:
 	mkdir -p debian/tmp/$(OCAML_STDLIB_DIR)/agrep

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d?)(\d?)/$1.$2/ \
  https://github.com/xavierleroy/ocamlagrep/tags .*/release(\d\S*)\.tar\.gz
